<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <template v-if="isDesktopPlatform">
        <div
          class="page-title"
          v-if="pageTitle"
        >
          {{ pageTitle }}
        </div>
        <div
          class="page-subtitle"
          v-if="pageSubTitle"
        >
          {{ pageSubTitle }}
        </div>
      </template>

      <q-card
        :square="!isDesktopPlatform"
        class="column no-wrap col"
      >
        <q-banner class="bg-grey-3 text-grey-8 q-mb-md">
          {{ explanationText }}
        </q-banner>

        <q-card-section v-if="computing">
          <div>
            <div
              class="column flex-center"
              style="height: 100%;"
            >
              <q-spinner
                color=""
                size="3em"
              />
              <translate>Computing nutrient requirements...</translate>
            </div>
          </div>
        </q-card-section>

        <q-card-section v-else-if="error">
          <div>
            <translate>
              There were some errors while computing the nutrient requirements.
            </translate>

            <p
              v-html="error"
              class="q-mt-md"
            />
          </div>
        </q-card-section>

        <div v-else-if="nutrientBalance">
          <KalkulackyHnojenieNutrientBalance
            :balance-items="balanceItems"
          />
        </div>

        <q-card-section class="q-mt-auto">
          <q-card-actions
            vertical
            align="stretch"
            class="q-pa-none"
          >
            <q-btn
              color="primary"
              text-color="white"
              @click="onClickNext"
            >
              <translate>Organic fertilization</translate>
            </q-btn>
            <q-btn
              flat
              color="primary"
              @click="onClickPrevious"
            >
              <translate>Previous</translate>
            </q-btn>
          </q-card-actions>
        </q-card-section>
      </q-card>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'

import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import FertilizationPlanMixin from 'src/pages/fieldbook/fertilization/mixins/FertilizationPlanMixin'
import KalkulackyHnojenieNutrientBalance from 'src/pages/fieldbook/fertilization/algorithms/kalkulacky-hnojenie/components/KalkulackyHnojenieNutrientBalance'
import queryKalkulackyHnojenieComputeNutrientBalance from 'src/pages/fieldbook/fertilization/algorithms/kalkulacky-hnojenie/graphql/queryKalkulackyHnojenieComputeNutrientBalance'
import { resultTypes } from 'src/services/fieldbook/fertilization/fertilizationPlan'

export default {
  name: 'KalkulackyHnojenieNutrientRequirementsPage',
  components: {
    GenericLayout,
    Header,
    Footer,
    KalkulackyHnojenieNutrientBalance
  },
  mixins: [PlatformMixin, AlgorithmsMixins, FertilizationPlanMixin],
  data () {
    return {
      computing: false,
      nutrientBalance: null,
      error: null
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Nutrient requirements')
    },
    pageSubTitle () {
      return 'Kalkulacky Hnojenie'
    },
    plot () {
      return this.$store.state.fertilizationPlan.target
    },
    storeParameters () {
      return this.$store.state.fertilizationPlan.parameters
    },
    storeResults: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.results
      },
      set (v) {
        this.updateParameter('results', v)
      }
    },
    computeNutrientBalanceParams () {
      const params = {}

      // Crop profile
      params.preFertilizationEffect = this.storeParameters.preFertilizationEffect.name
      params.cropProfileMainProductId = this.storeParameters.cropMainProduct.id
      params.cropProfileMainProductYield = this.storeParameters.cropMainProductTargetYield

      if (this.storeParameters.cropByProduct?.id) {
        params.cropProfileByProductId = this.storeParameters.cropByProduct.id
        params.cropProfileByProductYield = this.storeParameters.cropByProductTargetYield
      }

      // Soil
      if (this.storeParameters.soilDataIsUsed) {
        params.soil = {
          density: this.storeParameters.soilDensity.name,
          ph: this.storeParameters.soilPH,
          p: this.storeParameters.soilPhosphorusContent,
          k: this.storeParameters.soilPotassiumContent,
          mg: this.storeParameters.soilMagnesiumContent
        }
      }

      // NVZ
      if (this.storeParameters.isInNVZ) {
        params.soilNitrogenMineralizationId = this.storeParameters.soilNitrogenMineralization.id
        params.growingSeasonDuration = this.storeParameters.growingSeasonDuration
      }

      // Fertilizations
      params.fertilizations = []

      return params
    },
    fertilizationPlanResults () {
      return {
        plot_id: this.plot.id,
        plot_name: this.plot.name,
        plant_species_id: this.storeParameters.cropProfile.id,
        plant_species_name: this.storeParameters.cropProfile.name,
        crop_main_product_name: this.storeParameters.cropMainProduct.name,
        crop_yield: this.storeParameters.cropMainProductTargetYield,
        crop_yield_unit_of_measure_id: this.unitOfMeasures.TON_PER_HECTARE,
        crop_by_product_name: this.storeParameters.cropByProduct?.name,
        crop_by_product_yield: this.storeParameters.cropByProductTargetYield,
        element_recommendations: this.storeParameters.results.recommendations
      }
    },
    balanceItems () {
      return this.fertilizationPlanResults.element_recommendations
    },
    explanationText () {
      if (this.storeParameters.soilDataIsUsed) {
        return this.$gettext('The following requirements show the nutrients needed to achieve the crop target yield using soil data parameters.')
      } else {
        return this.$gettext('The following requirements show the nutrients needed to achieve the crop target yield.')
      }
    }
  },
  async mounted () {
    await this.computeNutrientBalance('network-only')
  },
  methods: {
    onClickPrevious () {
      const previousRouteName = this.$store.state.fertilizationPlan.parameters.isInNVZ ? 'kalkulackyHnojenieNVZ' : 'kalkulackyHnojenieSoil'
      this.$router.replace({
        name: previousRouteName
      })
    },
    onClickNext () {
      this.$router.push({
        name: 'kalkulackyHnojenieOrganicFertilization'
      })
    },
    async computeNutrientBalance (fetchPolicy) {
      try {
        this.computing = true

        const { data } = await this.$apollo.query({
          query: queryKalkulackyHnojenieComputeNutrientBalance,
          variables: this.computeNutrientBalanceParams,
          fetchPolicy
        })
        this.nutrientBalance = data?.nutrientBalance

        const chemicalElements = ['n', 'p', 'k', 'ca', 'mg']

        const recommendations = []
        for (const chemicalElement of chemicalElements) {
          const chemicalElementId = chemicalElement.toUpperCase()
          const chemicalElementRecommendations = [{
            chemical_element_id: chemicalElementId,
            quantity: this.nutrientBalance.nutrient_extraction_main_product[chemicalElement],
            result_type: resultTypes.MAIN_PRODUCT_EXTRACTION
          }, {
            chemical_element_id: chemicalElementId,
            quantity: this.nutrientBalance.nutrient_extraction_byproduct?.[chemicalElement],
            result_type: resultTypes.BY_PRODUCT_EXTRACTION
          }, {
            chemical_element_id: chemicalElementId,
            quantity: this.nutrientBalance.nutrient_n_biological_fixation[chemicalElement],
            result_type: resultTypes.BIOLOGICAL_FIXATION
          }, {
            chemical_element_id: chemicalElementId,
            quantity: this.nutrientBalance.nutrient_n_soil_mineralization[chemicalElement],
            result_type: resultTypes.SOIL_MINERALIZATION
          }, {
            chemical_element_id: chemicalElementId,
            quantity: this.nutrientBalance.nutrient_requirements[chemicalElement],
            result_type: resultTypes.RECOMMENDATION
          }]
          recommendations.push(...chemicalElementRecommendations)
        }

        this.storeResults = { recommendations }
      } catch (e) {
        console.error('Could not compute nutrient balance', e)
        this.error = e
      } finally {
        this.computing = false
      }
    }
  }
}
</script>
